﻿Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinGrid

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.UltraGrid1.DataSource = GridDataTable()
    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        Dim ucDropDown As New Infragistics.Win.UltraWinGrid.UltraCombo
        Dim utbtnTemp As New Infragistics.Win.UltraWinEditors.EditorButton
        ucDropDown.DataSource = SomeDataTable()
        ucDropDown.ValueMember = "ValueField"
        ucDropDown.DisplayMember = "MemberField"

        utbtnTemp = New Infragistics.Win.UltraWinEditors.EditorButton With {
            .Key = "Column123",
            .Text = "..."}

        ucDropDown.ButtonsLeft.Add(utbtnTemp)
        AddHandler ucDropDown.EditorButtonClick, AddressOf ucDropDown_EditorButtonClick

        ucDropDown.DropDownButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Always
        ucDropDown.MaxDropDownItems = 12

        e.Layout.Bands(0).Columns(0).EditorComponent = ucDropDown
        e.Layout.Bands(0).Columns(0).AutoCompleteMode = AutoCompleteMode.SuggestAppend
        e.Layout.Bands(0).Columns(0).Style = ColumnStyle.DropDown
        e.Layout.Bands(0).Columns(0).ButtonDisplayStyle = ButtonDisplayStyle.Always

    End Sub

    Private Sub ucDropDown_EditorButtonClick(sender As Object, e As EditorButtonEventArgs)
        MsgBox("Cell editor button clicked!")
    End Sub

    Private Sub UltraGrid1_InitializeRow(sender As Object, e As InitializeRowEventArgs) Handles UltraGrid1.InitializeRow
        'Dim ucDropDown As New Infragistics.Win.UltraWinGrid.UltraCombo
        'Dim utbtnTemp As New Infragistics.Win.UltraWinEditors.EditorButton
        'ucDropDown.DataSource = SomeDataTable()
        'ucDropDown.ValueMember = "ValueField"
        'ucDropDown.DisplayMember = "MemberField"

        'utbtnTemp = New Infragistics.Win.UltraWinEditors.EditorButton With {
        '     .Key = "Column123",
        '      .Text = "..."}

        'ucDropDown.ButtonsLeft.Add(utbtnTemp)
        'AddHandler ucDropDown.EditorButtonClick, AddressOf ucDropDown_EditorButtonClick

        'ucDropDown.DropDownButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Always
        'e.Row.Band.Columns("Some Col Name").EditorComponent = ucDropDown
        'e.Row.Band.Columns("Some Col Name").AutoCompleteMode = AutoCompleteMode.SuggestAppend
        'e.Row.Band.Columns("Some Col Name").Style = ColumnStyle.DropDown
        'e.Row.Band.Columns("Some Col Name").ButtonDisplayStyle = ButtonDisplayStyle.Always

        'ucDropDown.MaxDropDownItems = 12

    End Sub

    Private Function SomeDataTable() As DataTable

        Dim dt As New DataTable()

        dt.Columns.Add("ValueField", GetType(Integer))
        dt.Columns.Add("MemberField")

        For row As Integer = 1 To 100
            dt.Rows.Add(row, "Row " & row.ToString())
        Next

        Return dt
    End Function

    Private Function GridDataTable() As DataTable

        Dim dt As New DataTable()

        For col As Integer = 1 To 4
            dt.Columns.Add(String.Format("Column #{0}", col), GetType(Integer))
        Next

        For row As Integer = 1 To 10
            Dim addRow As DataRow = dt.NewRow()
            For Each column As DataColumn In dt.Columns
                addRow(column) = row
            Next

            dt.Rows.Add(addRow)
        Next

        Return dt
    End Function

End Class
